/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.61 Revision 1.110
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.110 2011/11/14 17:08:49 vapier Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10#
11# NB: If you add anything, please comment it!
12 12
13inherit eutils libtool 13inherit eutils libtool
14
15# @ECLASS-VARIABLE: WANT_AUTOCONF
16# @DESCRIPTION:
17# The major version of autoconf your package needs
18: ${WANT_AUTOCONF:=latest}
19
20# @ECLASS-VARIABLE: WANT_AUTOMAKE
21# @DESCRIPTION:
22# The major version of automake your package needs
23: ${WANT_AUTOMAKE:=latest}
24
25# @ECLASS-VARIABLE: WANT_LIBTOOL
26# @DESCRIPTION:
27# Do you want libtool? Valid values here are "latest" and "none".
28: ${WANT_LIBTOOL:=latest}
29
30# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
31# @INTERNAL
32# @DESCRIPTION:
33# CONSTANT!
34# The latest major version/slot of automake available on each arch.
35# If a newer version is stable on any arch, and is NOT reflected in this list,
36# then circular dependencies may arise during emerge @system bootstraps.
37# Do NOT change this variable in your ebuilds!
38_LATEST_AUTOMAKE='1.11'
14 39
15_automake_atom="sys-devel/automake" 40_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 41_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then 42if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in 43 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch 44 none) _automake_atom="" ;; # some packages don't require automake at all
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 45 # if you change the "latest" version here, change also autotools_run_tool
46 # this MUST reflect the latest stable major version for each arch!
47 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;;
21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 48 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac 49 esac
50 export WANT_AUTOMAKE
23fi 51fi
24 52
25if [[ -n ${WANT_AUTOCONF} ]] ; then 53if [[ -n ${WANT_AUTOCONF} ]] ; then
26 case ${WANT_AUTOCONF} in 54 case ${WANT_AUTOCONF} in
55 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 56 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
57 # if you change the “latest” version here, change also autotools_run_tool
28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 58 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
59 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
29 esac 60 esac
61 export WANT_AUTOCONF
30fi 62fi
31DEPEND="${_automake_atom} 63
32 ${_autoconf_atom} 64_libtool_atom="sys-devel/libtool"
33 sys-devel/libtool" 65if [[ -n ${WANT_LIBTOOL} ]] ; then
66 case ${WANT_LIBTOOL} in
67 none) _libtool_atom="" ;;
68 latest) ;;
69 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
70 esac
71 export WANT_LIBTOOL
72fi
73
74AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
34RDEPEND="" 75RDEPEND=""
76
77# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
78# @DESCRIPTION:
79# Set to 'no' to disable automatically adding to DEPEND. This lets
80# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
81# their own DEPEND string.
82: ${AUTOTOOLS_AUTO_DEPEND:=yes}
83if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
84 DEPEND=${AUTOTOOLS_DEPEND}
85fi
86
35unset _automake_atom _autoconf_atom 87unset _automake_atom _autoconf_atom
36 88
37# Variables: 89# @ECLASS-VARIABLE: AM_OPTS
38# 90# @DEFAULT_UNSET
39# AT_M4DIR - Additional director(y|ies) aclocal should search 91# @DESCRIPTION:
40# AM_OPTS - Additional options to pass to automake during 92# Additional options to pass to automake during
41# eautoreconf call. 93# eautoreconf call.
94
95# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
96# @DEFAULT_UNSET
97# @DESCRIPTION:
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 98# Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with 99# useful when elibtoolize needs to be ran with
44# particular options 100# particular options
45 101
46# Functions:
47#
48# eautoreconf() - Should do a full autoreconf - normally what most people
49# will be interested in. Also should handle additional
50# directories specified by AC_CONFIG_SUBDIRS.
51# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
52# to search for macro's.
53# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
54# with elibtoolize() from libtool.eclass
55# eautoconf - Runs autoconf.
56# eautoheader - Runs autoheader.
57# eautomake - Runs automake
58#
59
60# XXX: M4DIR should be depreciated 102# XXX: M4DIR should be deprecated
103# @ECLASS-VARIABLE: AT_M4DIR
104# @DESCRIPTION:
105# Additional director(y|ies) aclocal should search
61AT_M4DIR=${AT_M4DIR:-${M4DIR}} 106: ${AT_M4DIR:=${M4DIR}}
62AT_GNUCONF_UPDATE="no"
63 107
64 108# @FUNCTION: eautoreconf
109# @DESCRIPTION:
65# This function mimes the behavior of autoreconf, but uses the different 110# This function mimes the behavior of autoreconf, but uses the different
66# eauto* functions to run the tools. It doesn't accept parameters, but 111# eauto* functions to run the tools. It doesn't accept parameters, but
67# the directory with include files can be specified with AT_M4DIR variable. 112# the directory with include files can be specified with AT_M4DIR variable.
113#
114# Should do a full autoreconf - normally what most people will be interested in.
115# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
68eautoreconf() { 116eautoreconf() {
69 local pwd=$(pwd) x auxdir 117 local x auxdir g
70 118
71 if [[ -z ${AT_NO_RECURSIVE} ]]; then 119 if [[ -z ${AT_NO_RECURSIVE} ]]; then
72 # Take care of subdirs 120 # Take care of subdirs
73 for x in $(autotools_get_subdirs); do 121 for x in $(autotools_get_subdirs); do
74 if [[ -d ${x} ]] ; then 122 if [[ -d ${x} ]] ; then
75 cd "${x}" 123 pushd "${x}" >/dev/null
76 AT_NOELIBTOOLIZE="yes" eautoreconf 124 AT_NOELIBTOOLIZE="yes" eautoreconf
77 cd "${pwd}" 125 popd >/dev/null
78 fi 126 fi
79 done 127 done
80 fi 128 fi
81 129
82 auxdir=$(autotools_get_auxdir) 130 auxdir=$(autotools_get_auxdir)
83 131
84 einfo "Running eautoreconf in '$(pwd)' ..." 132 einfo "Running eautoreconf in '${PWD}' ..."
85 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 133 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
86 eaclocal 134 eaclocal
135 [[ ${CHOST} == *-darwin* ]] && g=g
136 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
137 _elibtoolize --copy --force --install
138 else
87 _elibtoolize --copy --force 139 _elibtoolize --copy --force
140 fi
88 eautoconf 141 eautoconf
89 eautoheader 142 eautoheader
90 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 143 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
91 144
92 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 145 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
93 146
94 # Call it here to prevent failures due to elibtoolize called _before_ 147 # Call it here to prevent failures due to elibtoolize called _before_
95 # eautoreconf. 148 # eautoreconf. We set $S because elibtoolize runs on that #265319
96 elibtoolize 149 S=${PWD} elibtoolize --force
97 150
98 return 0 151 return 0
99} 152}
100 153
154# @FUNCTION: eaclocal_amflags
155# @DESCRIPTION:
156# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
157# (most) of the crazy crap that people throw at us.
158eaclocal_amflags() {
159 local aclocal_opts amflags_file
160
161 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
162 [[ -e ${amflags_file} ]] || continue
163 # setup the env in case the pkg does something crazy
164 # in their ACLOCAL_AMFLAGS. like run a shell script
165 # which turns around and runs autotools. #365401
166 # or split across multiple lines. #383525
167 autotools_env_setup
168 aclocal_opts=$(sed -n \
169 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
170 # match the first line
171 s:[^=]*=::p; \
172 # then gobble up all escaped lines
173 : nextline /\\\\$/{ n; p; b nextline; } \
174 }" ${amflags_file})
175 eval aclocal_opts=\""${aclocal_opts}"\"
176 break
177 done
178
179 echo ${aclocal_opts}
180}
181
182# @FUNCTION: eaclocal
183# @DESCRIPTION:
101# These functions runs the autotools using autotools_run_tool with the 184# These functions runs the autotools using autotools_run_tool with the
102# specified parametes. The name of the tool run is the same of the function 185# specified parametes. The name of the tool run is the same of the function
103# without e prefix. 186# without e prefix.
104# They also force installing the support files for safety. 187# They also force installing the support files for safety.
188# Respects AT_M4DIR for additional directories to search for macro's.
105eaclocal() { 189eaclocal() {
106 local aclocal_opts
107
108 if [[ -n ${AT_M4DIR} ]] ; then
109 for x in ${AT_M4DIR} ; do
110 case "${x}" in
111 "-I")
112 # We handle it below
113 ;;
114 *)
115 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
116 aclocal_opts="${aclocal_opts} -I ${x}"
117 ;;
118 esac
119 done
120 fi
121
122 autotools_set_versions
123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 190 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
124 autotools_run_tool aclocal "$@" ${aclocal_opts} 191 autotools_run_tool aclocal $(autotools_m4dir_include) "$@" $(eaclocal_amflags)
125} 192}
126 193
194# @FUNCTION: _elibtoolize
195# @DESCRIPTION:
196# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
197# libtool.eclass.
127_elibtoolize() { 198_elibtoolize() {
128 local opts 199 local opts g=
129 local lttest
130 200
131 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 201 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
132 # check for both it and the current AC_PROG_LIBTOOL) 202 # check for both it and the current AC_PROG_LIBTOOL)
133 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 203 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
134 [[ -n $lttest ]] || return 0
135 204
136 [[ -f Makefile.am ]] && opts="--automake" 205 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
137 206
138 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 207 [[ ${CHOST} == *-darwin* ]] && g=g
139 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 208 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
140 209
141 # Need to rerun aclocal 210 # Need to rerun aclocal
142 eaclocal 211 eaclocal
143} 212}
144 213
214# @FUNCTION: eautoheader
215# @DESCRIPTION:
216# Runs autoheader.
145eautoheader() { 217eautoheader() {
146 # Check if we should run autoheader 218 # Check if we should run autoheader
147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 219 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions
149 NO_FAIL=1 autotools_run_tool autoheader "$@" 220 NO_FAIL=1 autotools_run_tool autoheader $(autotools_m4dir_include) "$@"
150} 221}
151 222
223# @FUNCTION: eautoconf
224# @DESCRIPTION:
225# Runs autoconf.
152eautoconf() { 226eautoconf() {
153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 227 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
154 echo 228 echo
155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 229 eerror "No configure.{ac,in} present in '${PWD}'!"
156 echo 230 echo
157 die "No configure.{ac,in} present!" 231 die "No configure.{ac,in} present!"
158 fi 232 fi
159 233
160 autotools_set_versions 234 autotools_run_tool autoconf $(autotools_m4dir_include) "$@"
161 autotools_run_tool autoconf "$@"
162} 235}
163 236
237# @FUNCTION: eautomake
238# @DESCRIPTION:
239# Runs automake.
164eautomake() { 240eautomake() {
165 local extra_opts 241 local extra_opts
242 local makefile_name
166 243
244 # Run automake if:
245 # - a Makefile.am type file exists
246 # - a Makefile.in type file exists and the configure
247 # script is using the AM_INIT_AUTOMAKE directive
248 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do
249 [[ -f ${makefile_name} ]] && break
250 done
167 [[ -f Makefile.am ]] || return 0 251 [[ -z ${makefile_name} ]] && return 0
168 252
169 autotools_set_versions 253 if [[ ${makefile_name} == *.in ]] ; then
254 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
255 return 0
256 fi
257
170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 258 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
171 local used_automake 259 local used_automake
172 local installed_automake 260 local installed_automake
173 261
174 installed_automake=$(automake --version | head -n 1 | \ 262 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
175 sed -e 's:.*(GNU automake) ::') 263 sed -e 's:.*(GNU automake) ::')
176 used_automake=$(head -n 1 < Makefile.in | \ 264 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
177 sed -e 's:.*by automake \(.*\) from .*:\1:') 265 sed -e 's:.*by automake \(.*\) from .*:\1:')
178 266
179 if [[ ${installed_automake} != ${used_automake} ]]; then 267 if [[ ${installed_automake} != ${used_automake} ]]; then
180 einfo "Automake used for the package (${used_automake}) differs from" 268 einfo "Automake used for the package (${used_automake}) differs from"
181 einfo "the installed version (${installed_automake})." 269 einfo "the installed version (${installed_automake})."
182 eautoreconf 270 eautoreconf
183 return 0 271 return 0
184 fi 272 fi
185 fi 273 fi
186 274
187 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 275 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
188 || extra_opts="${extra_opts} --foreign" 276 || extra_opts="${extra_opts} --foreign"
189 277
190 # --force-missing seems not to be recognized by some flavours of automake 278 # --force-missing seems not to be recognized by some flavours of automake
191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 279 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
192} 280}
193 281
194autotools_set_versions() { 282# @FUNCTION: eautopoint
195 [[ -n ${autotools_version_sets} ]] && return 0 283# @DESCRIPTION:
196 284# Runs autopoint (from the gettext package).
197 if [[ -n ${WANT_AUTOCONF} ]]; then 285eautopoint() {
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 286 autotools_run_tool autopoint "$@"
199 export WANT_AUTOCONF
200 einfo "Requested autoconf ${WANT_AUTOCONF}"
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
203 else
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/"
205 fi
206
207 if [[ -n ${WANT_AUTOMAKE} ]]; then
208 local latest_automake
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
210 latest_automake="latest: "
211 for amver in 1.10 1.9 1.8 1.7 1.6; do
212 WANT_AUTOMAKE="${amver}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break
214 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225} 287}
226 288
227# Internal function to run an autotools' tool 289# Internal function to run an autotools' tool
290autotools_env_setup() {
291 # We do the “latest” → version switch here because it solves
292 # possible order problems, see bug #270010 as an example.
293 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
294 local pv
295 for pv in ${_LATEST_AUTOMAKE} ; do
296 # has_version respects ROOT, but in this case, we don't want it to,
297 # thus "ROOT=/" prefix:
298 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
299 done
300 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
301 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
302 fi
303 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
304}
228autotools_run_tool() { 305autotools_run_tool() {
306 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
307 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
308 fi
309
310 autotools_env_setup
311
229 local STDERR_TARGET="${T}/$$.out" 312 local STDERR_TARGET="${T}/$1.out"
313 # most of the time, there will only be one run, but if there are
314 # more, make sure we get unique log filenames
315 if [[ -e ${STDERR_TARGET} ]] ; then
230 local ris 316 local i=1
317 while :; do
318 STDERR_TARGET="${T}/$1-${i}.out"
319 [[ -e ${STDERR_TARGET} ]] || break
320 : $(( i++ ))
321 done
322 fi
231 323
232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 324 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
234 325
235 ebegin "Running $@" 326 ebegin "Running $@"
236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 327 "$@" >> "${STDERR_TARGET}" 2>&1
237 ris=$? 328 eend $?
238 eend ${ris}
239 329
240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then 330 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
241 echo 331 echo
242 eerror "Failed Running $1 !" 332 eerror "Failed Running $1 !"
243 eerror 333 eerror
244 eerror "Include in your bugreport the contents of:" 334 eerror "Include in your bugreport the contents of:"
245 eerror 335 eerror
246 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 336 eerror " ${STDERR_TARGET}"
247 echo 337 echo
248 die "Failed Running $1 !" 338 die "Failed Running $1 !"
249 fi 339 fi
250} 340}
251 341
252# Internal function to check for support 342# Internal function to check for support
253autotools_check_macro() { 343autotools_check_macro() {
254 [[ -f configure.ac || -f configure.in ]] && \ 344 [[ -f configure.ac || -f configure.in ]] || return 0
255 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 345 local macro
346 for macro ; do
347 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
348 done
256 return 0 349 return 0
257} 350}
258 351
259# Internal function to get additional subdirs to configure 352# Internal function to get additional subdirs to configure
260autotools_get_subdirs() { 353autotools_get_subdirs() {
284 print res[1] 377 print res[1]
285 }' | uniq 378 }' | uniq
286 379
287 return 0 380 return 0
288} 381}
382
383autotools_m4dir_include() {
384 [[ -n ${AT_M4DIR} ]] || return
385
386 local include_opts=
387
388 for x in ${AT_M4DIR} ; do
389 case "${x}" in
390 "-I")
391 # We handle it below
392 ;;
393 *)
394 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
395 include_opts="${include_opts} -I ${x}"
396 ;;
397 esac
398 done
399
400 echo $include_opts
401}

Legend:
Removed from v.1.61  
changed lines
  Added in v.1.110

  ViewVC Help
Powered by ViewVC 1.1.20